using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms;
using Syncfusion.Drawing;

namespace SampleApplication
{
	#region customized User Control - code copied from GridRichTextEntryPanel and modified
	//here we add a color dialog button as a sample

	public class MyGridRichTextEntryPanel : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.Panel pnlFonts;
		private System.Windows.Forms.ComboBox fontComboBox;
		private System.Windows.Forms.ComboBox fontSizeComboBox;
		private System.Windows.Forms.Panel pnlFontsTB;
		private System.Windows.Forms.ToolBar tbAlign;
		private System.Windows.Forms.ToolBarButton laButton;
		private System.Windows.Forms.ToolBarButton centerButton;
		private System.Windows.Forms.ToolBarButton raButton;
		private System.Windows.Forms.RichTextBox richTextBox1;
		private System.Windows.Forms.Button btnSave;
		private System.Windows.Forms.Button btnCancel;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ToolBarButton boldButton;
		private System.Windows.Forms.ToolBarButton italicButton;
		private System.Windows.Forms.ToolBarButton underLineButton;
		private System.Windows.Forms.ToolBarButton colorButton;
		private System.Windows.Forms.ToolBar tbFont;
		private System.Windows.Forms.ColorDialog colorDialog1;
		private System.Windows.Forms.ToolBarButton toolBarButton3;
		private System.Windows.Forms.ToolBarButton DIndent;
		private System.Windows.Forms.ToolBarButton IIndent;
		private System.Windows.Forms.ImageList imageList1;

		bool initDone = false;

		/// <summary>
		/// Initializes a new <see cref="GridRichTextEntryPanel"/> object.
		/// </summary>
		public MyGridRichTextEntryPanel()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitForm call
			this.fontComboBox.DisplayMember = "Name";
			this.fontComboBox.ValueMember = "Name";
			this.fontComboBox.Items.AddRange(FontFamily.Families);
			this.fontComboBox.SelectedIndex = 2;
			this.fontSizeComboBox.SelectedIndex = 2;

			this.richTextBox1.TextChanged += new EventHandler(richTextBox1_TextChanged);

			initDone = true;
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MyGridRichTextEntryPanel));
			this.pnlFonts = new System.Windows.Forms.Panel();
			this.fontComboBox = new System.Windows.Forms.ComboBox();
			this.fontSizeComboBox = new System.Windows.Forms.ComboBox();
			this.pnlFontsTB = new System.Windows.Forms.Panel();
			this.tbFont = new System.Windows.Forms.ToolBar();
			this.boldButton = new System.Windows.Forms.ToolBarButton();
			this.italicButton = new System.Windows.Forms.ToolBarButton();
			this.underLineButton = new System.Windows.Forms.ToolBarButton();
			this.colorButton = new System.Windows.Forms.ToolBarButton();
			this.tbAlign = new System.Windows.Forms.ToolBar();
			this.laButton = new System.Windows.Forms.ToolBarButton();
			this.centerButton = new System.Windows.Forms.ToolBarButton();
			this.raButton = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton3 = new System.Windows.Forms.ToolBarButton();
			this.DIndent = new System.Windows.Forms.ToolBarButton();
			this.IIndent = new System.Windows.Forms.ToolBarButton();
			this.richTextBox1 = new System.Windows.Forms.RichTextBox();
			this.btnSave = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.colorDialog1 = new System.Windows.Forms.ColorDialog();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.pnlFonts.SuspendLayout();
			this.pnlFontsTB.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlFonts
			// 
			this.pnlFonts.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlFonts.Controls.Add(this.fontComboBox);
			this.pnlFonts.Controls.Add(this.fontSizeComboBox);
			this.pnlFonts.Controls.Add(this.pnlFontsTB);
			this.pnlFonts.Controls.Add(this.tbAlign);
			this.pnlFonts.Location = new System.Drawing.Point(1, 2);
			this.pnlFonts.Name = "pnlFonts";
			this.pnlFonts.Size = new System.Drawing.Size(423, 32);
			this.pnlFonts.TabIndex = 6;
			// 
			// fontComboBox
			// 
			this.fontComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.fontComboBox.DisplayMember = "Name";
			this.fontComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.fontComboBox.Location = new System.Drawing.Point(0, 1);
			this.fontComboBox.Name = "fontComboBox";
			this.fontComboBox.Size = new System.Drawing.Size(144, 21);
			this.fontComboBox.TabIndex = 5;
			this.fontComboBox.ValueMember = "Name";
			this.fontComboBox.SelectedIndexChanged += new System.EventHandler(this.fontComboBox_SelectedIndexChanged);
			// 
			// fontSizeComboBox
			// 
			this.fontSizeComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.fontSizeComboBox.Items.AddRange(new object[] {
																  "8",
																  "9",
																  "10",
																  "11",
																  "12",
																  "14",
																  "15",
																  "16",
																  "17",
																  "18",
																  "19",
																  "20",
																  "40",
																  "50",
																  "70",
																  "80",
																  "100"});
			this.fontSizeComboBox.Location = new System.Drawing.Point(149, 0);
			this.fontSizeComboBox.Name = "fontSizeComboBox";
			this.fontSizeComboBox.Size = new System.Drawing.Size(48, 21);
			this.fontSizeComboBox.TabIndex = 4;
			this.fontSizeComboBox.SelectedIndexChanged += new System.EventHandler(this.fontSizeComboBox_SelectedIndexChanged);
			// 
			// pnlFontsTB
			// 
			this.pnlFontsTB.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlFontsTB.Controls.Add(this.tbFont);
			this.pnlFontsTB.Location = new System.Drawing.Point(185, 0);
			this.pnlFontsTB.Name = "pnlFontsTB";
			this.pnlFontsTB.Size = new System.Drawing.Size(104, 24);
			this.pnlFontsTB.TabIndex = 5;
			// 
			// tbFont
			// 
			this.tbFont.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.tbFont.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.tbFont.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																					  this.boldButton,
																					  this.italicButton,
																					  this.underLineButton,
																					  this.colorButton});
			this.tbFont.ButtonSize = new System.Drawing.Size(23, 22);
			this.tbFont.Divider = false;
			this.tbFont.Dock = System.Windows.Forms.DockStyle.None;
			this.tbFont.DropDownArrows = true;
			this.tbFont.ImageList = this.imageList1;
			this.tbFont.Location = new System.Drawing.Point(16, 0);
			this.tbFont.Name = "tbFont";
			this.tbFont.ShowToolTips = true;
			this.tbFont.Size = new System.Drawing.Size(152, 26);
			this.tbFont.TabIndex = 4;
			this.tbFont.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.tbFont_ButtonClick);
			// 
			// boldButton
			// 
			this.boldButton.ImageIndex = 3;
			this.boldButton.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.boldButton.ToolTipText = "Bold";
			// 
			// italicButton
			// 
			this.italicButton.ImageIndex = 4;
			this.italicButton.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.italicButton.ToolTipText = "Italic";
			// 
			// underLineButton
			// 
			this.underLineButton.ImageIndex = 5;
			this.underLineButton.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.underLineButton.ToolTipText = "Underline";
			// 
			// colorButton
			// 
			this.colorButton.ImageIndex = 6;
			this.colorButton.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.colorButton.ToolTipText = "Color";
			// 
			// tbAlign
			// 
			this.tbAlign.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tbAlign.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.tbAlign.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																					   this.laButton,
																					   this.centerButton,
																					   this.raButton,
																					   this.toolBarButton3,
																					   this.DIndent,
																					   this.IIndent});
			this.tbAlign.ButtonSize = new System.Drawing.Size(23, 22);
			this.tbAlign.Divider = false;
			this.tbAlign.Dock = System.Windows.Forms.DockStyle.None;
			this.tbAlign.DropDownArrows = true;
			this.tbAlign.ImageList = this.imageList1;
			this.tbAlign.Location = new System.Drawing.Point(297, 0);
			this.tbAlign.Name = "tbAlign";
			this.tbAlign.ShowToolTips = true;
			this.tbAlign.Size = new System.Drawing.Size(128, 26);
			this.tbAlign.TabIndex = 7;
			this.tbAlign.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.tbAlign_ButtonClick);
			// 
			// laButton
			// 
			this.laButton.ImageIndex = 1;
			this.laButton.Pushed = true;
			this.laButton.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.laButton.ToolTipText = "Left Aligned";
			// 
			// centerButton
			// 
			this.centerButton.ImageIndex = 0;
			this.centerButton.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.centerButton.ToolTipText = "Center Aligned";
			// 
			// raButton
			// 
			this.raButton.ImageIndex = 2;
			this.raButton.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.raButton.ToolTipText = "Right Aligned";
			// 
			// toolBarButton3
			// 
			this.toolBarButton3.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// DIndent
			// 
			this.DIndent.ImageIndex = 7;
			// 
			// IIndent
			// 
			this.IIndent.ImageIndex = 8;
			// 
			// richTextBox1
			// 
			this.richTextBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.richTextBox1.Location = new System.Drawing.Point(0, 26);
			this.richTextBox1.Name = "richTextBox1";
			this.richTextBox1.Size = new System.Drawing.Size(424, 174);
			this.richTextBox1.TabIndex = 7;
			this.richTextBox1.Text = "";
			this.richTextBox1.SelectionChanged += new System.EventHandler(this.richTextBox1_SelectionChanged);
			// 
			// btnSave
			// 
			this.btnSave.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnSave.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnSave.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnSave.Location = new System.Drawing.Point(264, 205);
			this.btnSave.Name = "btnSave";
			this.btnSave.Size = new System.Drawing.Size(72, 24);
			this.btnSave.TabIndex = 8;
			this.btnSave.Text = "&Save";
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.CausesValidation = false;
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(352, 205);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(72, 24);
			this.btnCancel.TabIndex = 8;
			this.btnCancel.Text = "&Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// MyGridRichTextEntryPanel
			// 
			this.Controls.Add(this.btnSave);
			this.Controls.Add(this.richTextBox1);
			this.Controls.Add(this.pnlFonts);
			this.Controls.Add(this.btnCancel);
			this.Name = "MyGridRichTextEntryPanel";
			this.Size = new System.Drawing.Size(432, 235);
			this.pnlFonts.ResumeLayout(false);
			this.pnlFontsTB.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private FontStyle curStyle = FontStyle.Regular;
		private HorizontalAlignment curAlignment = HorizontalAlignment.Left;

		private void tbFont_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if (!initDone)
				return;

			tbAlign_ButtonClick(sender, e);
		}

		private void tbAlign_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if (!initDone)
				return;

			if(e.Button == this.boldButton)
			{
				if(this.boldButton.Pushed)
					this.curStyle = this.curStyle | FontStyle.Bold;
				else
					this.curStyle &= ~FontStyle.Bold;
			}
			else if(e.Button == this.italicButton)
			{
				if(this.italicButton.Pushed)
					this.curStyle = this.curStyle | FontStyle.Italic;
				else
					this.curStyle &= ~FontStyle.Italic;
			}
			else if(e.Button == this.underLineButton)
			{
				if(this.underLineButton.Pushed)
					this.curStyle = this.curStyle | FontStyle.Underline;
				else
					this.curStyle &= ~FontStyle.Underline;
			}
			else if(e.Button == this.colorButton)
			{
				if(this.colorDialog1.ShowDialog() == DialogResult.OK)
				{
					this.richTextBox1.SelectionColor = this.colorDialog1.Color;
				}
			}
			else if(e.Button == this.laButton)
			{
				if(this.laButton.Pushed)
				{
					this.curAlignment = HorizontalAlignment.Left;
					this.centerButton.Pushed = false;
					this.raButton.Pushed = false;
				}
				this.richTextBox1.SelectionAlignment = this.curAlignment;
			}
			else if(e.Button == this.centerButton)
			{
				if(this.centerButton.Pushed)
				{
					this.curAlignment = HorizontalAlignment.Center;
					this.laButton.Pushed = false;
					this.raButton.Pushed = false;
				}
				this.richTextBox1.SelectionAlignment = this.curAlignment;
			}
			else if(e.Button == this.raButton)
			{
				if(this.raButton.Pushed)
				{
					this.curAlignment = HorizontalAlignment.Right;
					this.laButton.Pushed = false;
					this.centerButton.Pushed = false;
				}
				this.richTextBox1.SelectionAlignment = this.curAlignment;
			} 
			else if(e.Button == this.DIndent)
			{
				this.richTextBox1.SelectionIndent=this.richTextBox1.SelectionIndent - 10;
				this.DIndent.Pushed=false;
			}
			else if(e.Button == this.IIndent)
			{
				if (this.richTextBox1.SelectionIndent + 10 <= this.richTextBox1.Width - 40)
				{
					this.richTextBox1.SelectionIndent=this.richTextBox1.SelectionIndent + 10;					
					this.IIndent.Pushed=false;
				}
				this.IIndent.Pushed=false;
			}

			this.richTextBox1.Focus();
			this.UpdateFont();
		}

		private void fontComboBox_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (!initDone)
				return;
			this.richTextBox1.Focus();
			this.UpdateFont();
		}

		private void fontSizeComboBox_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (!initDone)
				return;
			this.richTextBox1.Focus();
			this.UpdateFont();
		}

		private void UpdateFont()
		{
			try
			{
				string family = this.fontComboBox.SelectedItem.ToString();
				int n2 = family.IndexOf("]");
				int n3 = family.IndexOf("=");
				if (n2 != -1 && n2 > n3)
					family = family.Substring(family.IndexOf("=") + 1, family.IndexOf("]") - family.IndexOf("=") - 1);
				this.richTextBox1.SelectionFont = FontUtil.CreateFont(family, float.Parse(this.fontSizeComboBox.Text), this.curStyle);
			}
			catch{}
		}

		private void btnSave_Click(object sender, System.EventArgs e)
		{
			if (Save != null)
				Save(this, EventArgs.Empty);
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			if (Cancel != null)
				Cancel(this, EventArgs.Empty);
		}

		private void richTextBox1_SelectionChanged(object sender, System.EventArgs e)
		{
			if (!initDone)
				return;

			initDone = false;
			Font f = richTextBox1.SelectionFont;

			if (f != null)
			{
				try
				{
					curStyle = f.Style;

					this.fontComboBox.SelectedIndex = this.fontComboBox.FindString(f.Name);
					this.fontSizeComboBox.Text = f.SizeInPoints.ToString();
					this.boldButton.Pushed = (f.Style & FontStyle.Bold) != 0;
					this.underLineButton.Pushed = (f.Style & FontStyle.Underline) != 0;
					this.italicButton.Pushed = (f.Style & FontStyle.Italic) != 0;

					curAlignment = this.richTextBox1.SelectionAlignment;
					this.laButton.Pushed = (curAlignment == HorizontalAlignment.Left);
					this.centerButton.Pushed = (curAlignment == HorizontalAlignment.Center);
					this.raButton.Pushed = (curAlignment == HorizontalAlignment.Right);
				}
				catch
				{
				}
			}
			// TODO: What about text color?
			initDone = true;
		}

		/// <override/>
		protected override bool ProcessDialogKey(Keys keyData)
		{
			//Syncfusion.Diagnostics.TraceUtil.TraceCurrentMethodInfo(keyData);
			if (this.ActiveControl == this.richTextBox1)
			{
				if (keyData == Keys.Enter)
					return false;
			}
			return base.ProcessDialogKey (keyData);
		}


		/// <summary>
		/// Occurs when user clicked the "Save" button.
		/// </summary>
		public event EventHandler Save;

		/// <summary>
		/// Occurs when user clicked the "Cancel" button.
		/// </summary>
		public event EventHandler Cancel;

		/// <summary>
		/// A reference to the <see cref="RichTextBox"/> that is beeing displayed.
		/// </summary>
		public System.Windows.Forms.RichTextBox RichTextBox
		{
			get
			{
				return this.richTextBox1;
			}
		}

		private void richTextBox1_TextChanged(object sender, EventArgs e)
		{
			richTextBox1_SelectionChanged(sender, e);
			this.richTextBox1.Font = Font;
		}
	}

	#endregion

	#region derived GridRichTextBoxCellModel - overriden to use derived renderer

	public class MyGridRichTextBoxCellModel : GridRichTextBoxCellModel
	{
		public MyGridRichTextBoxCellModel(GridModel grid)
			: base(grid)
		{
		}

		public override GridCellRendererBase CreateRenderer(GridControlBase control)
		{
			return new MyGridRichTextBoxCellRenderer(control, this);
		}

	}
	
	#endregion
	
	#region derived GridRichTextBoxCellRenderer -  overridden to use customized user control

	public class MyGridRichTextBoxCellRenderer : GridRichTextBoxCellRenderer
	{
		private MyGridRichTextEntryPanel panel = null;

		public MyGridRichTextBoxCellRenderer(GridControlBase grid, GridCellModelBase cellModel)
			: base(grid, cellModel)
		{
		}

		protected /*internal*/ override void InitializeDropDownContainer()
		{
			//base.InitializeDropDownContainer();

			panel = new MyGridRichTextEntryPanel();
			panel.KeyDown += new KeyEventHandler(PanelKeyDown);
			AssignRtf(panel.RichTextBox);
			this.DropDownContainer.Controls.Add(panel);
		}

		public override void DropDownContainerShowingDropDown(object sender, CancelEventArgs e)
		{
			this.DropDownContainer.PopupHost.FormBorderStyle = FormBorderStyle.Sizable;
			this.DropDownContainer.PopupHost.Size = new Size(432, 235);
			this.DropDownContainer.Dock = DockStyle.Fill;
			GridStyleInfo style = Grid.Model[RowIndex, ColIndex];
			panel.RichTextBox.Font = style.GdipFont;
			if (this.HasControlValue)
				AssignRtf(panel.RichTextBox, ControlValue.ToString());
			else
				AssignRtf(panel.RichTextBox, style.Text);

			Color backColor = Color.FromArgb(255, style.Interior.BackColor);
			panel.RichTextBox.BackColor = backColor;
			panel.RichTextBox.ForeColor = style.TextColor;
			panel.Dock = DockStyle.Fill;
			panel.Save += new EventHandler(PanelSave);
			panel.Cancel +=new EventHandler(PanelCancel);
			//	base.DropDownContainerShowingDropDown(sender, e);
		}

		public override void DropDownContainerShowedDropDown(object sender, EventArgs e)
		{
			panel.RichTextBox.Focus();
		}

		/// <override/>
		public override void DropDownContainerCloseDropDown(object sender, PopupClosedEventArgs e)  
		{
			if (e.PopupCloseType == PopupCloseType.Done)
			{
				if (this.NotifyCurrentCellChanging())
				{
					ControlValue = panel.RichTextBox.Rtf;
					this.NotifyCurrentCellChanged();
				}
			}
			Grid.InvalidateRange(GridRangeInfo.Cell(RowIndex, ColIndex), GridRangeOptions.MergeCoveredCells); // Merge all cells
			Grid.ResetText();
			Grid.Refresh();	

			//	base.DropDownContainerCloseDropDown(sender, e);
		}


		void AssignRtf(RichTextBox rtb)
		{
			if (HasControlValue)
				AssignRtf(panel.RichTextBox, this.ControlValue.ToString());
			else if (HasControlText)
				AssignRtf(panel.RichTextBox, this.ControlText);
		}

		void AssignRtf(RichTextBox rtb, string rtf)
		{
			if (RichTextPaint.IsValidRtf(rtf))
				rtb.Rtf = rtf;
			else 
				rtb.Text = rtf;
		}

	}
	#endregion

}